\section{Effectors and Receptors}
\label{sec:effectors-and-receptors}
This section states the general behaviour of the virtual effectors and
receptors without defining the transition functions or finite state automatons
governing the actions of those subsystems.

\paragraph{The virtual effectors $e_{1,m}$ and $e_{1,g}$} are fully defined in
\emph{Example: Picking randomly located objects} \cite{RPM2021}, slides 167-190
and 191-196 respectively. Nevertheless their behaviour is summarized here too:

\subparagraph{The 6dof manipulator virtual effector $e_{1,m}$} moves the end
effector based on two types of inputs: A Cartesian pose or position-force
control parameters. Therefore it is able to move simply to a given pose or
follow an accurate trajectory when controlled using position-force parameters.
When no input is given to the manipulator, this will hold its position. It will
output the homogeneous matrix corresponding to the current Cartesian pose of
the manipulator as well as the current force/torque exerted by the
end-effector. See \autoref{table:manipulator-buffers} for detailed information
on its interaction with the control subsystem.

\subparagraph{The two-state gripper virtual effector $e_{1,g}$} closes or opens
the gripper jaws given a value for the desired aperture (distance between
jaws). If no input is provided, it will hold the current aperture. Which is one
of its outputs, together with the measured motor current (which is proportional
to the force exerted by the jaws). See \autoref{table:gripper-buffers} for
detailed information on the gripper input and output.

\paragraph{The Kinect sensor virtual receptor $r_{1,k}$} is defined similarly to
\emph{Example: Picking randomly located objects} \cite{RPM2021}, slides 197-213
with the exception that the \emph{Hypothesis verification} step of the
transition function of the active behaviour of the receptor \textbf{verifies
that the object is a red cube on a conveyor belt having a white tape with
dimensions of $3cm\pm 0.5cm$ at a velocity not greater than 0.05$m/s$ within a
bounding box known inside the manipulator workspace}.

It will ignore objects that do not match the already mentioned \emph{location},
\emph{speed}, \emph{shape}, \emph{dimensions} and \emph{colour pattern}
requirements. An extension of the system proposed in this report could take
into account the possibility of modifying said requirements dynamically via a
User Interface.

In order to verify the object speed, The Kinect sensor virtual receptor will
track the different objects over time using previous images and finding
correspondences between them in order to provide not only the object's position
but its instantaneous velocity with respect to the Kinect reference frame,
which will be also available to the control subsystem as it is described in
\autoref{table:kinect-buffers} with a complete description of the rest of
outputs available from this virtual receptor.